KeyError#receiver and KeyError#name

02/11/2016 01:41 PM - ksss (Yuki Kurihara)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

Description

I propose KeyError#receiver and KeyError#name (or KeyError#key) like NameError.

I think these method help to debug.

And will be able to find typo on did_you_mean gem.

See also https://github.com/yuki24/did_you_mean/pull/71

begin

  h = {foo: 1, bar: 2}

  h.fetch(:bax)

rescue KeyError => e

  p e.receiver #=> {foo: 1, bar: 2} equal `h`

  p e.name     #=> :bax

end

 
begin

  h = {foo: 1, bar: 2, baz: 3}

  h.fetch_values(:bar, :bax)

rescue KeyError => e

  p e.receiver #=> {foo: 1, bar: 2, baz: 3} equal `h`

  p e.name     #=> :bax

end

 
begin

  ENV.fetch("HOEM")

rescue KeyError => e

  p e.receiver #=> ENV

  p e.name     #=> "HOEM"

end

 
begin

  sprintf("%<foo>d", {fooo: 1})

rescue KeyError => e

  p e.receiver #=> {fooo: 1}

  p e.name     #=> :foo

end

Associated revisions

Revision 13f5dcb9f25cf07ef22baa5aded490395700b283 - 09/18/2017 08:05 AM - nobu (Nobuyoshi Nakada)

error.c: KeyError#receiver and KeyError#key

error.c: new method KeyError#receiver and KeyError#key.

[Feature #12063]

hash.c: make KeyError object with receiver and key.

sprintf.c: ditto.

Author:    ksss co000ri@gmail.com

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@59955 b2dd03c8-39d4-4d8f-98ff-823fe69b080e
Revision 13f5dcb9 - 09/18/2017 08:05 AM - nobu (Nobuyoshi Nakada)

error.c: KeyError#receiver and KeyError#key

error.c: new method KeyError#receiver and KeyError#key.

[Feature #12063]

hash.c: make KeyError object with receiver and key.

sprintf.c: ditto.

Author:    ksss co000ri@gmail.com

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@59955 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 02/16/2016 02:56 PM - ksss (Yuki Kurihara)

I made a patch https://github.com/ruby/ruby/pull/1251

#2 - 10/26/2016 11:30 AM - ferdinandrosario@gmail.com (ferdinand rosario)

- Assignee set to core

#3 - 10/26/2016 11:59 AM - hsbt (Hiroshi SHIBATA)

- Assignee deleted (core)

#4 - 11/25/2016 06:22 AM - matz (Yukihiro Matsumoto)

Agreed.

Matz.

#5 - 04/02/2017 06:23 AM - ksss (Yuki Kurihara)

Which method name is best?

"name" referenced from "NameError".

But I think, "key" is also good. Because this is "KeyError" method.

The patch on github is using "key".

Thanks.

#6 - 04/02/2017 10:00 AM - Eregon (Benoit Daloze)

I think "name" is more consistent with other exceptions, such as NameError#name and NoMethodError#name (by inheritance).

#7 - 06/16/2017 08:23 AM - matz (Yukihiro Matsumoto)

Keys may not be names (strings and symbols), so I think key is a sufficient name for the method.

Matz.

#8 - 09/18/2017 08:05 AM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Closed

Applied in changeset trunk|r59955.

error.c: KeyError#receiver and KeyError#key

error.c: new method KeyError#receiver and KeyError#key.

[Feature #12063]

hash.c: make KeyError object with receiver and key.

sprintf.c: ditto.

Author:    ksss co000ri@gmail.com
